#!/usr/bin/python
# -*- coding: utf-8 -*-

import sys, os
import json
from contextlib import contextmanager
import contextlib


sys.path.append('/home/geoint/GeoSentinel')
from geosentinel import APISentinel
from geosentinel import polygonToBox

from datetime import date 

#@contextmanager
#def suppress_stdout():
#    with open(os.devnull, "w") as devnull:
#        old_stdout = sys.stdout
#        sys.stdout = devnull
#        try:  
#            yield
#        finally:
#            sys.stdout = old_stdout

def findSentinelProducts(wkt, startDate, endDate, platform, cloud):
	sentinel = APISentinel.APISentinel('asalazarg',  'geo135asg')

	products = sentinel.getProducts(wkt, (startDate, endDate), {"platformname":platform, "cloudcoverpercentage":"[0 TO "+str(cloud)+"]"})

	return products

def main(argv):

	if len(sys.argv) != 8:
		print("Usage: " + argv[0] + " <WKT Polygon> <Start Date> <End Date> <Platform> <Maximum Cloud %> <Source> <Destination>")
	else:
#	        with suppress_stdout():
#		with contextlib.redirect_stdout(None):
		wkt = polygonToBox.getWKTPolygonBoundingBox(sys.argv[1], True)
		productList = findSentinelProducts(wkt, sys.argv[2], sys.argv[3], sys.argv[4], sys.argv[5])

		fileNames = [productList[k]['filename'].replace("SAFE", "zip").replace("L1C", "L2A") for k in productList.keys() ]

		inDir =  sys.argv[6]
		outdir =  sys.argv[7]
		dirList = os.listdir(inDir)
		
		matchingProducts = set(fileNames).intersection(set(dirList))
		print ( str(len(matchingProducts))+" of " + str(len(fileNames)) +" products found.")	


		for f in matchingProducts:
			print (f)
			os.system("ln -s " + inDir+f + " " + outdir+f)
#			print ("ln -s " + inDir+f + " " + outdir+f)
		print (str(len(matchingProducts)) + " Linked to " + outdir)
		
if __name__ == "__main__":
	main(sys.argv)


#cat results2.txt | xargs -I{} ln -s {} ~/newlinks

